{ lipulesanne                                                              }
{ paigutada NxN malelauale N lippu nii, et nad ksteist ei tulista          }

{ edasiarendus: lippude tulistamise kontroll efektiivsemaks                 }
{ variantide arv ei vhene, kll aga he variandi tlemise aeg             }
{ massiivi rr on vaja ainult siis, kui tahame leitud variante kasutada      }

const maxn = 30;                    { maksimaalne laua suurus / lippude arv }

var nn : integer;                               { laua suurus / lippude arv }
var rr : array [1..maxn] of integer;                     { lippude asukohad }
var vr : array [1..maxn] of boolean;                           { vabad read }
var d1 : array [2..2*maxn] of boolean;                { vabad / diagonaalid }
var d2 : array [1-maxn..maxn-1] of boolean;           { vabad \ diagonaalid }
var xx, yy : longint;                          { variantide, lahenduste arv }

{ kontrollib, et vli [r,v] pole tule all }
function ok(r, v : integer) : boolean;
begin
   xx := xx + 1;                                        { loendame variandi }
   exit(vr[r] and d1[r + v] and d2[r - v]);
end;

{ paneb lipu kohale [r,v] }
procedure pane(r, v : integer);
begin
   rr[v] := r;
   vr[r] := false; d1[r + v] := false; d2[r - v] := false;
end;

{ eemaldab lipu kohalt [r,v] }
procedure vota(r, v : integer);
begin
   vr[r] := true; d1[r + v] := true; d2[r - v] := true;
end;

{ otsib kohta jrgmisele lipule }
procedure otsi(n : integer);
var r : integer;
begin
   if n > nn then begin                         { kui kik lipud paigutatud }
      { kui me siia juame, siis on see juba kindlalt lahendus }
      yy := yy + 1;                                    { loendame lahenduse }
   end else begin
      for r := 1 to nn do begin
         if ok(r, n) then begin                    { kui on osaline variant }
            pane(r, n);                                   { uus lipp kohale }
            otsi(n + 1);                          { paigutame jrgmise lipu }
            vota(r, n);                                   { uus lipp minema }
         end;
      end;
   end;
end;

var i : integer;
begin
   write('N = '); readln(nn);
   for i := 1 to nn do vr[i] := true;             { alguses kik read vabad }
   for i := 2 to 2*nn do d1[i] := true;       { ja kik / diagonaalid vabad }
   for i := 1-nn to nn-1 do d2[i] := true;    { ja kik \ diagonaalid vabad }
   xx := 0; yy := 0;
   otsi(1);
   writeln('Vaadeldud ', xx, ' varianti, leitud ', yy, ' lahendust');
end.
